var g_tick = 0;
var g_width = 100;
var g_height = 100;
var g_scale = 1.0;
var g_up = 1;
var g_x = 0;
var g_y = 0;
var g_sx = 0;
var g_sy = 0;
var g_text = 0;
var g_score = 0;
var g_mode = 1;

var g_fallingThings = [
    {"sprite":"p1",  "hit":1, "bonus":0, "xp":0, "x":0, "y":0, "vy":0},
    {"sprite":"p2",  "hit":1, "bonus":0, "xp":0, "x":0, "y":0, "vy":0},
    {"sprite":"p3",  "hit":1, "bonus":0, "xp":0, "x":0, "y":0, "vy":0},
	{"sprite":"p4",  "hit":1, "bonus":0, "xp":0, "x":0, "y":0, "vy":0},
    {"sprite":"star","hit":1, "bonus":1, "xp":0, "x":0, "y":0, "vy":0}
];


registerComponent("vertical_dodge", "", "vertical_dodge", "Vertical Dodge", "vertical_dodge_init", "vertical_dodge_resize", "vertical_dodge_refresh", "", "on_gameover")
function vertical_dodge_init(width, height){
	//tell the component to clip anything hanging out the edge of the component
	setProperty(self,"clip_to_bounds",1)

	// create a gamekit
	rk = createComponent(self, "renderkit", 0, 0, 100, 100)
	setProperty(rk,"spritesheet","space");
	
	g_text = createComponent(self, "text",0,0,100,10);
	setProperty(g_text,"resize_type", 2);
	setProperty(g_text,"font_size", 28);
	setProperty(g_text,"font_align", 1);
	setProperty(g_text,"center_vertical", 1);
	setProperty(g_text,"font_color", '0xFFFFFFFF');
	setProperty(g_text,"text", "0");
	

	g_width = getProperty(self,'width');
	g_height = getProperty(self,'height');
	
	//scale so sprites are same size whatever DPI
	g_scale = g_width / 1000.0;
	
	//background
	setup_sprite_tile('bkg1');
	setup_sprite_tile('bkg2');

	//ship
	renderkitSpriteCreate(rk, -1, 'ship', 0, 0 ,g_scale ,0 , 255);
	
	//falling things
	for(var i=0; i<g_fallingThings.length; i++){
		g_fallingThings[i].xp = Math.random();
		g_fallingThings[i].x = g_fallingThings[i].xp * g_width;
		g_fallingThings[i].y = (400 - (i * 350)) * g_scale;
		var cx = g_fallingThings[i].x;
		var cy = g_fallingThings[i].y
		renderkitSpriteCreate(rk, -1, g_fallingThings[i].sprite, cx, cy ,g_scale ,0 , 255);	
	}
	
	// register for the per frame tick event
	bindEvent(rk,"on_tick","vertical_dodge_on_tick");
	bindEvent(rk,"on_down","vertical_dodge_on_down");
	bindEvent(rk,"on_move","vertical_dodge_on_move");
	bindEvent(rk,"on_up",  "vertical_dodge_on_up");
}

function setup_sprite_tile(cellname){
	for(var i=0; i<16; i++){ 
		renderkitSpriteCreate(rk, -1, cellname, 0,0,1,0, 255)
	}
}


function update_sprite_tile(layer,cellname,x,y){
	var ox = x;
	var oy = y;
	if (rk){
		var swidth = renderkitSpriteGetWidth(rk, -1, cellname);
		var sheight = renderkitSpriteGetHeight(rk, -1, cellname);

		if (x<-swidth) 	ox = (ox%swidth);
		if (x>0)    	ox = -swidth + (ox%swidth);
		if (y<-sheight) oy = (oy%sheight);
		if (y>0)    	oy = -sheight + (oy%sheight);

		//this applies the requested offset and shuffles the tiles so we are still covering the target area
		for(var i=0; i<4; i++){ 
			for(var j=0; j<4; j++){ 
				renderkitSpriteUpdate(rk,layer*16 + (i)*4 + (j),-1, cellname, (i*swidth + ox - swidth) * g_scale*3.0,(j*sheight + oy - sheight) * g_scale*3.0,g_scale*3.0,0, 255);
			}
		}
	}
}

function vertical_dodge_on_tick(){
	rk = self;
	if (g_mode){
		g_tick++;
		vertical_dodge_draw();
	}
}

function vertical_dodge_on_down(x, y, tid){
	g_x = x;
	g_y = y;
	g_up = 0;
}

function vertical_dodge_on_up(x, y, tid){
	g_up = 1;
}

function vertical_dodge_on_move(x, y, tid){
	g_x = x;
	g_y = y;
}

function vertical_dodge_resize(width, height){	
	rk = getComponentChild(self,0);	
	g_x = 0;	
	vertical_dodge_draw();
}

function vertical_dodge_refresh(width, height){
	//update after changes to component properties
	rk = getComponentChild(self,0);	
	g_x = 0;
	vertical_dodge_draw();
}

register("vertical_dodge_restart","vertical dodge restart","")
function vertical_dodge_restart(){
	g_x = 0;
	g_score = 0;
	g_mode = 1;
	vertical_dodge_draw();
}

function vertical_dodge_draw(){
	g_width = getProperty(rk,'width');
	g_height = getProperty(rk,'height');
	g_scale = g_width / 1200.0;

	//update positions
	var offset_x = -g_x;
	var offset_y = g_tick * 5;
	g_sx = (g_x + g_sx) / 2.0;
	g_sy = (g_y + g_sy) / 2.0;

	//set a default if starting
	if (g_x==0){
		g_score = 0;
		var p = getComponentParent(rk)
		g_text = getComponentChild(p,1);
		setProperty(g_text,"text", g_score);
		g_mode = 1;
		g_sx = g_width / 2.0;
		g_sy = g_height / 1.2;
		g_x = g_sx;
		g_y = g_sy;
		for(var i=0; i<g_fallingThings.length; i++){
			resetFallingThing(i);
		}
	}
	
	//move background
	update_sprite_tile(0,'bkg2', offset_x * 0.2, offset_y * 0.2)
	update_sprite_tile(1,'bkg1', offset_x * 0.3, offset_y * 0.3)
	
	//move ship
	renderkitSpriteUpdate(rk, 32, -1, 'ship', g_sx, g_sy - g_scale*150, g_scale, 0, 255)

	//move falling things
	for(var i=0; i<g_fallingThings.length; i++){
		g_fallingThings[i].y += g_fallingThings[i].vy;
		if (g_fallingThings[i].bonus == 1){ 
			// flashing bonus
			renderkitSpriteUpdate(rk, 33 + i, -1, g_fallingThings[i].sprite, g_fallingThings[i].x, g_fallingThings[i].y ,g_fallingThings[i].scale ,0 , 160 + 90 * Math.sin(g_tick / 10.0));	
		}else{ 
			//normal solid falling thing
			renderkitSpriteUpdate(rk, 33 + i, -1, g_fallingThings[i].sprite, g_fallingThings[i].x, g_fallingThings[i].y ,g_fallingThings[i].scale ,0 , 255);	
		}
		
		//check if we have hit a falling thing 
		if (g_fallingThings[i].hit == 1){ 
			var noseconeDistance = lineDistance(g_sx, g_sy - 300*g_scale, g_fallingThings[i].x, g_fallingThings[i].y) 
			var engineDistance = lineDistance(g_sx, g_sy, g_fallingThings[i].x, g_fallingThings[i].y)
			if (engineDistance < g_fallingThings[i].scale * 190 || noseconeDistance < g_fallingThings[i].scale * 190){
				if (g_fallingThings[i].bonus == 1){ 
					g_score += 1;
					var p = getComponentParent(rk)
					g_text = getComponentChild(p,1);
					setProperty(g_text,"text",g_score);
					resetFallingThing(i);
				}else{
					var p = getComponentParent(rk)
					g_text = getComponentChild(p,1);
					setProperty(g_text,"text","Game Over : " + g_score);
					g_mode = 0;
					//raise event 
					print('raise event')
					raiseEvent(p, 'on_gameover','{"value":"1"}');				
				}
			}
		}
		
		//check if falling thing is off the bottom
		if(g_fallingThings[i].y > g_height * 1.33){
			resetFallingThing(i);
		}
	}

}

function lineDistance( px1, py1, px2, py2 )
{
  var xs = 0;
  var ys = 0;
  xs = px2 - px1;
  xs = xs * xs;
  ys = py2 - py1;
  ys = ys * ys;
  return Math.sqrt( xs + ys );
}

function resetFallingThing(i){
	g_fallingThings[i].vy = Math.random() * 4.0 + 2.0;
	g_fallingThings[i].xp = Math.random();
	g_fallingThings[i].x = g_fallingThings[i].xp * g_width;
	g_fallingThings[i].y =  -300 - (i * 350) * g_scale;
	g_fallingThings[i].scale = g_scale * (2.0 + Math.random())/3.0;
}
